// ProgressData.h: interface for the ProgressData class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROGRESSDATA_H__34824FCA_C228_4167_9039_2438EB1BF653__INCLUDED_)
#define AFX_PROGRESSDATA_H__34824FCA_C228_4167_9039_2438EB1BF653__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>

class ProgressData  
{
public:
	int GetDoneCount();
	int GetAnnotatedCount();
	int GetImageCount();
	int GetTubeCount();
	void Reset();
  void ResetAnnotated();
  void ResetDone();
  const std::vector<bool>* GetTubeList();
  const std::vector<bool>* GetWindowList();
  const std::vector<bool>* GetSessionList();
	bool GetExists(int tube, int window, int session);
	void SetExists(int tube, int window, int session);
	bool GetAnnotated(int tube, int window, int session);
	void SetAnnotated(int tube, int window, int session);
	bool GetDone(int tube, int window, int session);
	void SetDone(int tube, int window, int session);
	ProgressData();
	virtual ~ProgressData();
  
//these are no longer used
//	int GetLastInWindow(int tube, int window);
//	int GetLastInSession(int tube, int session);
//	float GetFractionOfWindow(int tube, int window);
//	float GetFractionOfSession(int tube, int window);

private:
  std::vector<bool> m_tube_list;
  std::vector<bool> m_window_list;
  std::vector<bool> m_session_list;
  std::vector< std::vector< std::vector<bool> > > m_exist_list;
  std::vector< std::vector< std::vector<bool> > > m_annotated_list;
  std::vector< std::vector< std::vector<bool> > > m_done_list;
  int m_exist_count;
  int m_annotated_count;
  int m_done_count;
  int m_tube_count;
};

#endif // !defined(AFX_PROGRESSDATA_H__34824FCA_C228_4167_9039_2438EB1BF653__INCLUDED_)
