#if !defined(AFX_TUBECONTROL_H__F49BF60A_846F_4738_A79E_97FE1188756F__INCLUDED_)
#define AFX_TUBECONTROL_H__F49BF60A_846F_4738_A79E_97FE1188756F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TubeControl.h : header file
//

#include "ProgressData.h"
#include <vector>

/////////////////////////////////////////////////////////////////////////////
// TubeControl window

class TubeControl : public CStatic
{
// Construction
public:
	TubeControl(ProgressData *data);

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(TubeControl)
	public:
	virtual void OnFinalRelease();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~TubeControl();
	void SetSession(int session);

	// Generated message map functions
protected:
	//{{AFX_MSG(TubeControl)
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(TubeControl)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()
private:
	void GetAt(CPoint point, int *tube, int *window, CRect *rect);
	COLORREF ChooseColor(int tube, int window);
  class WindowRect : public CRect
  {
  public:
    int window;

    WindowRect();
    WindowRect(CPoint point, CSize size, int window);
  };
  class TubeRect : public CRect
  {
  public:
    int tube;
    std::vector<WindowRect> windows;

    TubeRect();
    TubeRect(CPoint point, CSize size, int tube);
  };

	ProgressData *m_data;
  std::vector<TubeRect> m_tubes;
  int m_session;

	CSize m_control_size;
  CSize m_tube_size;
  CSize m_window_size;

	int m_control_margin;
	int m_tube_spacing;
	int m_tube_margin;
  int m_tube_top;
	int m_window_spacing;

	void PlaceWindows();
	void DrawWindows(CPaintDC *dc);
	void DrawTube(CRect tube, CPaintDC *dc);
	void DrawWindow(CRect window, COLORREF color, CPaintDC *dc);

  COLORREF COLOR_NOT_EXIST;
  COLORREF COLOR_NOT_ANNOTATED;
  COLORREF COLOR_NOT_DONE;
  COLORREF COLOR_DONE;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TUBECONTROL_H__F49BF60A_846F_4738_A79E_97FE1188756F__INCLUDED_)
